﻿namespace NETing.ExperimentsConsole.Experiments.Abstract.Trec
{
    using System;
    using System.Collections;
    using System.Collections.Generic;
    using System.IO;

    using Index.Documents.Parser;
    using System.Linq;

    internal sealed class TrecQueryLogReader : IEnumerable<Tuple<int, Term[]>>, IDisposable
    {
        private readonly StreamReader queryLog;

        public TrecQueryLogReader(StreamReader queryLog)
        {
            this.queryLog = queryLog;
        }

        public IEnumerator<Tuple<int, Term[]>> GetEnumerator()
        {
            while(!queryLog.EndOfStream)
            {
                string[] query = queryLog.ReadLine().Split(new[] {':'}, 2);
                yield return new Tuple<int, Term[]>(int.Parse(query[0]), query[1].Split(' ').Select(s => new Term(s)).ToArray());
            }
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            return GetEnumerator();
        }

        public void Dispose()
        {
            queryLog.Dispose();
        }
    }
}
