﻿namespace NETing.ExperimentsConsole.Experiments.IndexConsole
{
    using System.Collections.Generic;
    using Abstract;

    using Commands.Build;
    using Commands.Query;
    
    [Experiment(Name = "Index console")]
    internal class IndexConsole : AbstractIndexConsole, IExperiment
    {
        protected override IEnumerable<IIndexConsoleCommand> GetCommands()
        {
            return new IIndexConsoleCommand[]
            {
                new BuildIndex(),
                new ExecuteQueries(),
                new QueryBenchMark(),
            };
        }

        public IndexConsole()
        {
            IndexSystemConfig.BufferCount = 1024;
            IndexSystemConfig.BufferSlices = 1;
        }
    }
}


