﻿namespace NETing.ExperimentsConsole.Experiments.QueryExecutionExperiment.Commands
{
    using System;
    using System.IO;
    using System.Linq;

    using Index.QueryLanguage;

    internal sealed class ExecuteQueryInTrace : AbstractQueryTraceCommand
    {
        public override string Name
        {
            get { return "Run single query"; }
        }

        public override string ShortDesc
        {
            get { return "Will run a single query for a query trace."; }
        }

        public override void Execute(string arg)
        {
            FileInfo queryTrace = GetFileInput("Enter full path to query trace: ");
            int queryId = GetIntegerInput("Enter id of query to run: ", 0);

            Query[] queries = LoadQueries(queryTrace).Where(q => q.Id == queryId).ToArray();
            Console.WriteLine("Running the query!");
            DoExecuteQueryTrace(queries, false, 1);
            Console.WriteLine("Finished!");
        }
    }
}
