﻿namespace NETing.ExperimentsConsole.Experiments.QueryExecutionExperiment.Commands.Experiments
{
    using System.Collections.Generic;
    using System.IO;

    using Abstract.Commands;

    using Index.Controller.Configurations;
    using Index.QueryLanguage;

    internal abstract class AbstractQueryExperiment : IQueryExperiment
    {
        protected  AbstractQueryExperiment()
        {
            WarmUp = 0;
            Runs = 5;
            ConcurrencyLevel = 4;
        }

        public abstract string Name { get; }
        public abstract IEnumerable<FileInfo> Traces { get; }

        public int WarmUp { get; set; }
        public int Runs { get; set; }
        public bool Dense {  get; set; }

        public virtual bool Concurrent
        {
            get { return ConcurrencyLevel > 1; }
        }

        public int ConcurrencyLevel {  get; set; }

        public virtual IEnumerable<IPostingFileConfig> Configs
        {
            get { return Configure.configs; }
        }

        public virtual IEnumerable<Query> Filter(IEnumerable<Query> queries)
        {
            return queries;
        }
    }
}
