﻿namespace NETing.ExperimentsConsole.Experiments.QueryExecutionExperiment.Commands.Experiments
{
    using System.Collections.Generic;
    using System.IO;

    internal sealed class HistogramIntersectionExperiment : AbstractQueryExperiment
    {
        private const string basePath = "..\\traces\\histogram\\06.efficiency_topics.all.intersection.min1res.min1res.";
        private readonly string bucket;
        private readonly FileInfo traceFile;

        public HistogramIntersectionExperiment(string bucket)
        {
            this.bucket = bucket;
            traceFile = new FileInfo(basePath + bucket);
        }

        public override string Name
        {
            get { return "intersection.histogram." + bucket; }
        }

        public override IEnumerable<FileInfo> Traces
        {
            get { yield return traceFile; }
        }
    }
}
