﻿namespace NETing.ExperimentsConsole.Experiments.QueryExecutionExperiment.Commands.Experiments
{
    using System.Collections.Generic;
    using System.IO;

    internal sealed class HistogramPathExperiment : AbstractQueryExperiment
    {
        private const string basePath = "..\\traces\\histogram\\06.efficiency_topics.all.path.";
        private const string baseNext = ".min1res.min1res.";

        private readonly string path;
        private readonly string bucket;
        private readonly FileInfo traceFile;

        public HistogramPathExperiment(string path, string bucket)
        {
            this.bucket = bucket;
            this.path = path;
            traceFile = new FileInfo(basePath + path + baseNext + bucket);
        }


        public override string Name
        {
            get { return "path." + path + ".histogram." + bucket; }
        }

        public override IEnumerable<FileInfo> Traces
        {
            get { yield return traceFile; }
        }
    }
}
