﻿namespace NETing.ExperimentsConsole.Experiments.QueryExecutionExperiment.Commands.Experiments
{
    using System.Collections.Generic;
    using System.IO;

    using Index.QueryLanguage;

    internal sealed class PathExperiment : AbstractQueryExperiment
    {
        private readonly string path;
        
        public PathExperiment(string path, bool dense)
        {
            this.path = path;
            Dense = dense;
        }

        public override string Name
        {
            get { return "path." + path + "." + (Dense ? "dense" : "regular"); }
        }

        public override IEnumerable<Query> Filter(IEnumerable<Query> queries)
        {
            foreach (Query query in queries)
            {
                query.Dense = Dense;
                yield return query;
            }
        }

        public override IEnumerable<FileInfo> Traces
        {
            get { yield return new FileInfo("..\\traces\\path." + path + ".min1res"); }
        }
    }
}
