﻿namespace NETing.ExperimentsConsole.Experiments.UtilityConsole.Commands
{
    using System;
    using System.IO;
    using System.Text;
    using Abstract;
    using Abstract.Commands;
 
    using Index.Controller.Configurations;
    using Utils;

    internal sealed class MemoryLeak : AbstractConsoleCommand
    {
        public override string Name
        {
            get { return "MemoryLeak"; }
        }

        public override string ShortDesc
        {
            get { return "Leaks memory";  }
        }

        public override void Execute(string arg)
        {
            var subDir = new DirectoryInfo("leak");
            if (!subDir.Exists)
            {
                subDir.Create();
            }

            int i = 0;
            while (true)
            {
                var experimentLog = new FileInfo(subDir.FullName + "\\experimentLog." + (i++) + ".log");

                using (TextWriter logWriter = new StreamWriter(experimentLog.OpenWrite()))
                {
                    var logLineBuilder = new StringBuilder(1024);
                    var teededLogWriter = new Tee(Console.Out, logWriter); 

                    teededLogWriter.WriteLine("Starting experiment: " + i);
                    foreach (IPostingFileConfig config in Configure.configs)
                    {
                        IndexConsole.ConfigureIndexSystem(config);
                        var configResultFile = new FileInfo(subDir.FullName + "\\" + i + "." + config.Name + ".timing");
                        teededLogWriter.WriteLine("Configuring for index system: " + config.Name);
                        teededLogWriter.WriteLine("Results will be in: " + configResultFile);
                        
                        teededLogWriter.WriteLine("Starting experiments for config: " + config.Name);
                        using (TextWriter resultWriter = new StreamWriter(configResultFile.OpenWrite()))
                        {
                            var teededResultWriter = new Tee(teededLogWriter, resultWriter);

                            for (int j = 0; j < 5; j++)
                            {
                                logLineBuilder.Clear();
                                // var timing = DoExecuteQueryTrace(queries, experiment.Concurrent, experiment.ConcurrencyLevel);
                                //logLineBuilder
                                //    .Append(timing.ExecutedQueries).Append('\t')
                                //    .Append(timing.TotalMillisecond).Append('\t')
                                //    .Append(timing.TotalLatency).Append('\t')
                                //    .Append(timing.Throughput);

                                teededResultWriter.WriteLine(logLineBuilder.ToString());
                            }
                        }

                        teededLogWriter.WriteLine("Finished experiments for config: " + config.Name);
                    }
                }
            }
        }
    }
}
