﻿namespace NETing.ExperimentsConsole
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using Experiments;
    
    internal sealed class Program
    {
        private static readonly IList<ExperimentAttribute> experiments
            = new List<ExperimentAttribute>();

        static Program()
        {
            foreach (var experiment in ExperimentAttribute
                .GetInstalledExperiments().OrderBy(exp => exp.Name))
            {
                experiments.Add(experiment);
            }
        }

        private static void ListExperiments()
        {
            Console.WriteLine("Installed experiments:");
            int i = 0;
            foreach (var experiment in experiments)
            {
                Console.WriteLine((i++) + ": " + experiment.Name);
            }
        }

        private static void Step()
        {
            ListExperiments();
            Console.Write("experiment number> ");
            int experiment = int.Parse(Console.ReadLine() ?? "");
            experiments[experiment].Instance.Execute();
        }

        private static void Main(string[] args)
        {
            Step();

            Console.WriteLine("Press enter to exit.");
            Console.ReadLine();
        }
    }
}


