﻿namespace NETing.ExperimentsConsole.Utils
{
    using System.Collections.Generic;
    using System.IO;
    using System.Text;

    public sealed class Tee : TextWriter
    {
        private readonly IEnumerable<TextWriter> writers;

        public override Encoding Encoding
        {
            get { return Encoding.Default; }
        }

        public Tee(params TextWriter[] writers)
        {
            this.writers = writers;
        }

        public override void Write(char[] buffer, int index, int count)
        {
            foreach (TextWriter writer in writers)
            {
                writer.Write(buffer, index, count);
            }
        }

        public override void Flush()
        {
            foreach (TextWriter writer in writers)
            {
                writer.Flush();
            }
        }

        protected override void Dispose(bool disposing)
        {
            base.Dispose(disposing);
            foreach (TextWriter writer in writers)
            {
                writer.Dispose();
            }
        }
    }
}
