﻿namespace NETing.Index.Documents.DocumentModel.Scope
{
    using System;
    using NUnit.Framework;
    using System.Linq;

    [TestFixture]
    public sealed class PathTypeLcpTest
    {
        [Test]
        public void TestPathTypeLcp()
        {
            var directory = new ScopeDirectory();
            ScopeDirectory.Cursor cursor = directory.GetCursor();
            cursor.Enter("a");
            cursor.Enter("b");
            cursor.Enter("c");
            cursor.Exit();
            cursor.Enter("d");
            cursor.Exit();
            cursor.Exit();
            cursor.Enter("c");

            foreach (var pathType in directory.PathTypes.Take(directory.NumberOfPaths))
            {
                Console.WriteLine(pathType);
            }

            Console.WriteLine("----------");

            foreach (var pathType1 in directory.PathTypes.Take(directory.NumberOfPaths))
            {
                foreach (var pathType2 in directory.PathTypes.Take(directory.NumberOfPaths))
                {
                    Console.WriteLine("LCP: " + pathType1 + ", " + pathType2);
                    Console.WriteLine(PathTypeLcp.Lcp(pathType1, pathType2));
                }
            }

            Console.WriteLine("----------");
        }
    }
}
