﻿namespace NETing.Index.PathMatching
{
    using System;
    using Documents.DocumentModel.Scope;
    using NUnit.Framework;

    [TestFixture]
    public class PathMatcherTest
    {
        private static readonly ScopeDirectory scopeDirectory = new ScopeDirectory();
        private static readonly PathMatcher pathMatcher;

        static PathMatcherTest()
        {
            var cursor = scopeDirectory.GetCursor();
            cursor.Enter("hello");
            cursor.Enter("you");
            cursor.Enter("are");
            cursor.Enter("boo");
            cursor.Exit();
            cursor.Enter("foo");
            cursor.Enter("this");
            cursor.Exit();
            cursor.Enter("that");
            cursor.Exit();
            cursor.Exit();
            cursor.Exit();
            cursor.Exit();
            cursor.Enter("mongo");
            cursor.Enter("this");
            cursor.Enter("that");
            cursor.Enter("foo");
            cursor.Enter("foo");
            cursor.Enter("foo");
            cursor.Exit();

            pathMatcher = new PathMatcher(scopeDirectory);
        }

        [Test]
        public void TestPathMatcher()
        {
            foreach (var pathType in scopeDirectory.PathTypes)
            {
                Console.WriteLine(pathType);
            }

            Console.WriteLine("-----");

            foreach (var pathType in pathMatcher.MatchingPaths("/hello//this/*//*"))
            {
                Console.WriteLine(pathType);
            }

            Console.WriteLine(scopeDirectory.NumberOfPaths);
        }


    }
}


