﻿namespace NETing.Index.PathMatching.Syntax
{
    using System.Collections.Generic;
    using NUnit.Framework;

    [TestFixture]
    public class ParserTest
    {
        private static readonly string query1 = "/hello//nice/boo";

        private static readonly IList<ExpressionToken> tokens1 = new List<ExpressionToken>()
                                                                     {
                                                                         new ExpressionToken { Type = TokenType.Child, Position = 0 },
                                                                         new ExpressionToken { Type = TokenType.ElementTag, Position = 1, Value = "hello" },
                                                                         new ExpressionToken { Type = TokenType.Descendant, Position = 6 },
                                                                         new ExpressionToken { Type = TokenType.ElementTag, Position = 8, Value = "nice" },
                                                                         new ExpressionToken { Type = TokenType.Child, Position = 12 },
                                                                         new ExpressionToken { Type = TokenType.ElementTag, Position = 13, Value = "boo" }
                                                                     };
            
        [Test]
        public void TestParser()
        {
            TestQuery(query1, tokens1);
        }

        private static void TestQuery(string query, IEnumerable<ExpressionToken> expected)
        {
            IEnumerator<ExpressionToken> expectedEnumer = expected.GetEnumerator();
            foreach (var token in Parser.ParseExpression(query))
            {
                Assert.That(expectedEnumer.MoveNext());
                Assert.AreEqual(expectedEnumer.Current, token);
            }
        }
    }
}


