﻿
namespace NETing.Index.Utils.Compression
{
    using NUnit.Framework;

    [TestFixture]
    public class PrefixedVByteTest
    {
        [Test]
        public void TestPrefixedVByteUInt32()
        {
            var buffer = new byte[5];
            for (uint i = uint.MinValue; i < uint.MaxValue; i = (i << 1) + 1)
            {
                int len = PrefixedVByte.Encode(i, buffer, 0);
                uint read;
                Assert.AreEqual(len, PrefixedVByte.Decode(buffer, 0, out read));
                Assert.AreEqual(i, read);

                len = PrefixedVByte.Encode(i + 1, buffer, 0);
                Assert.AreEqual(len, PrefixedVByte.Decode(buffer, 0, out read));
                Assert.AreEqual(i + 1, read);

                if (i > 0)
                {
                    len = PrefixedVByte.Encode(i - 1, buffer, 0);
                    Assert.AreEqual(len, PrefixedVByte.Decode(buffer, 0, out read));
                    Assert.AreEqual(i - 1, read);
                }
            }
        }
    }
}


