﻿namespace NETing.Index.Utils.Compression
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class Simple9Test
    {
        private const int NumElements = 5000;

        [Test]
        public void TestSimple9()
        {
            Random rnd = new Random(9);
            for (int magnitude = 0; magnitude < 28; magnitude++)
            {
                uint[] data = new uint[NumElements];
                for (int i = 0; i < NumElements; i++)
                {
                    data[i] = (uint)rnd.Next(0, (int)Math.Pow(2.0, magnitude));
                }

                uint[] output = new uint[NumElements];
                for (int i = 0, j = 0; i < NumElements; i += Simple9.Encode(data, output, i, j), j++)
                {
                }

                uint[] decompressed = new uint[NumElements];
                for (int i = 0, j = 0; i < NumElements; i += Simple9.Decode(output, decompressed, j, i), j++)
                {
                }

                for (int i = 0; i < NumElements; i++)
                {
                    Assert.AreEqual(data[i], decompressed[i], "At position: " + i + " magnitude: " + magnitude);
                }   
            }
        }
    }
}


