﻿namespace NETing.Index.ColumnAccess.Implementations.NPfor
{
    using Utils.Compression;
    using Writers;

    public sealed class NPforDocumentIdColumnWriter : AbstractDocumentIdColumnWriter
    {
        private readonly NPforEncodingWrapper wrapper;
        private uint maxDocumentId;

        internal NPforDocumentIdColumnWriter(NPforEncodingWrapper wrapper)
        {
            this.wrapper = wrapper;
        }

        public override int MaxHeaderBytes
        {
            get { return 5; }
        }

        public override int WriteHeader(byte[] buffer, int offset)
        {
            return PrefixedVByte.Encode(maxDocumentId, buffer, offset);
        }

        public override int Write(byte[] buffer, int offset)
        {
            maxDocumentId = values[count - 1];

            for (int i = count - 1; i > 0; i--)
            {
                values[i] -= (values[i - 1] + 1);
            }

            return wrapper.EncodeSingle(buffer, offset, values, 0, count);
        }
    }
}
