﻿namespace NETing.Index.ColumnAccess.Implementations.NPfor
{
    using Writers;

    public sealed class NPforFrequencyColumnWriter : AbstractFrequencyColumnWriter
    {
        private readonly NPforEncodingWrapper wrapper;
        private readonly uint[] valuesWrapped = new uint[128];

        internal NPforFrequencyColumnWriter(NPforEncodingWrapper wrapper)
        {
            this.wrapper = wrapper;
        }

        public override int Write(byte[] buffer, int offset)
        {
            for (int i = 0; i < count; i++)
            {
                valuesWrapped[i] = (uint)(values[i] - 1);
            }
            
            return wrapper.EncodeSingle(buffer, offset, valuesWrapped, 0, count);
        }
    }
}
