﻿namespace NETing.Index.ColumnAccess.Implementations.PrefixVByte
{
    using Utils.Compression;
    using Writers;

    public sealed class PrefixVByteDocumentIdColumnWriter : AbstractDocumentIdColumnWriter
    {
        public override int MaxHeaderBytes
        {
            get { return 4; }
        }

        public override int WriteHeader(byte[] buffer, int offset)
        {
            return PrefixedVByte.Encode(values[count - 1], buffer, offset);
        }

        public override int Write(byte[] buffer, int offset)
        {
            offset = PrefixedVByte.Encode(values[0], buffer, offset);
            for (int i = 1; i < count; i++)
            {
                offset = PrefixedVByte.Encode(values[i] - values[i - 1] - 1, buffer, offset);
            }

            return offset;
        }
    }
}
