﻿namespace NETing.Index.ColumnAccess.Implementations.PrefixVByte
{
    using Utils.Compression;
    using Writers;

    public sealed class PrefixVBytePositionColumnWriter : AbstractPositionColumnWriter
    {
        public override void Add(ushort[] values, int count)
        {
            for (int i = count - 1; i > 0; i--)
            {
                values[i] -= (ushort) (values[i - 1] + 1);   
            }

            base.Add(values, count);
        }

        public override int Write(byte[] buffer, int offset)
        {
            for (int i = 0; i < count; i++)
            {
                offset = PrefixedVByte.Encode(values[i], buffer, offset);
            }

            return offset;
        }
    }
}
