﻿namespace NETing.Index.ColumnAccess.Implementations.PrefixVByte
{
    using Writers;

    using Utils.Compression;

    public sealed class PrefixVByteScopeColumnWriter : AbstractScopeColumnWriter
    {
        private ushort extraBytes;

        public override int MaxHeaderBytes
        {
            get { return 3; }
        }

        public override int WriteHeader(byte[] buffer, int offset)
        {
            return PrefixedVByte.Encode(extraBytes, buffer, offset);
        }

        public override int Write(byte[] buffer, int offset)
        {
            int pathTypeStart = offset;
            for (int i = 0; i < count; i++)
            {
                offset = PrefixedVByte.Encode(pathTypes[i], buffer, offset);
            }

            extraBytes = (ushort)(offset - pathTypeStart - count);

            for (int i = 0; i < deweyCount; i++)
            {
                offset = PrefixedVByte.Encode(deweyElements[i], buffer, offset);
            }

            return offset;
        }
    }
}
