﻿namespace NETing.Index.ColumnAccess.Readers
{
    public abstract class AbstractChunkEnumerator
    {
        public int CurrentOccurrenceId
        {
            get; protected set;
        }

        public int TotalOccurrences
        {
            get; private set;
        }

        public int TotalDocuments
        {
            get; private set;
        }

        protected virtual void SetupChunk(int totalDocuments, uint totalOccurrences)
        {
            TotalOccurrences = (int)totalOccurrences;
            TotalDocuments = totalDocuments;
        }

        public virtual int ReadHeader(byte[] buffer, int offset, uint totalOccurrences)
        {
            return offset;
        }
    }
}
