﻿namespace NETing.Index.ColumnAccess.Readers
{
    using PostingFile;

    public abstract class AbstractDocumentChunkEnumerator : AbstractChunkEnumerator
    {
        protected int FrequencyBufferOffset { get; set; }

        public abstract bool MoveNext();

        public abstract ushort Frequency { get; }

        public abstract uint Current { get; }

        public abstract int RemainingDocuments { get;  }

        public int LastOccurrenceInCurrent
        {
            get { return CurrentOccurrenceId + Frequency; }
        }

        public virtual int SkipTo(uint documentId)
        {
            if (CurrentOccurrenceId < 0)
            {
                if (!MoveNext())
                {
                    return TotalOccurrences + 1;
                }
            }

            if (Current >= documentId)
            {
                return CurrentOccurrenceId;
            }

            bool hasNext = MoveNext();
            while (Current < documentId && hasNext)
            {
                hasNext = MoveNext();
            }


            if (!hasNext)
            {
                return TotalOccurrences + 1;
            }

            return CurrentOccurrenceId;
        }

        public int MoveToDocumentContaining(long occurrenceId)
        {
            if (CurrentOccurrenceId < 0)
            {
                MoveNext();
            }

            while (LastOccurrenceInCurrent <= occurrenceId)
            {
                MoveNext();
            }

            return CurrentOccurrenceId;
        }

        public abstract void LoadChunk(
            PostingFileDataReader dataReader,
            long documentFilePosition,
            uint documentChunkLength,
            long frequencyFilePosition,
            uint frequencyChunkLength,
            int chunkCount,
            uint occurrences);
        
        
    }
}