﻿namespace NETing.Index.ColumnAccess.Readers
{
    using Documents.DocumentModel.Scope;

    using PostingFile;

    public abstract class AbstractDocumentColumnReader
    {
        public ScopeDirectory ScopeDirectory { get; set; }

        public abstract AbstractDocumentChunkEnumerator CreateEnumerator();

        public static void InitializeEnumerator(
            AbstractDocumentChunkEnumerator enumerator,
            PostingFileDataReader dataReader,
            long documentFilePosition,
            uint documentChunkLength,
            long frequencyFilePosition,
            uint frequencyChunkLength,
            int documentsInChunk,
            uint occurrences)
        {
            enumerator.LoadChunk(
                dataReader, 
                documentFilePosition, 
                documentChunkLength, 
                frequencyFilePosition,
                frequencyChunkLength, 
                documentsInChunk, 
                occurrences);
        }
    }
}