﻿namespace NETing.Index.ColumnAccess.Readers
{
    using PostingFile;

    public abstract class AbstractPositionChunkEnumerator : AbstractChunkEnumerator
    {
        public abstract bool MoveNext();

        public abstract ushort Current { get; }

        public virtual void NewDocument(uint frequency)
        {
        }

        public virtual void MoveTo(
            int documentStartPosition, 
            int withinDocumentPosition,
            uint documentFrequency)
        {
            if (withinDocumentPosition >= TotalOccurrences)
            {
                return;
            }

            if (documentStartPosition > CurrentOccurrenceId)
            {
                while (CurrentOccurrenceId < documentStartPosition - 1)
                {
                    MoveNext();    
                }

                NewDocument(documentFrequency);    
            }

            while (CurrentOccurrenceId < withinDocumentPosition)
            {
                MoveNext();
            }
        }

        public abstract void LoadChunk(
            PostingFileDataReader dataReader,
            long filePosition,
            uint chunkLength,
            uint occurrences);
    }
}