﻿namespace NETing.Index.ColumnAccess.Writers
{
    using System;
    using Utils.ByteArrays;

    public abstract class AbstractPositionColumnWriter : AbstractColumnWriter
    {
        protected ushort[] values = new ushort[5 * 128];

        public int MaxBytes
        {
            get { return count << 1; }
        }

        public virtual void Add(ushort[] values, int count)
        {
            if (this.values.Length < this.count + count)
            {
                Array.Resize(ref this.values, (this.count + count) << 1);
            }

            BlockCopy.Copy(values, 0, this.values, this.count << 1, count << 1);
            this.count += count;
        }
    }
}
