﻿namespace NETing.Index.Controller.Configurations.ConcreteConfigurations
{
    using ColumnAccess.Implementations.PrefixVByte;
    using ColumnAccess.Readers;
    using ColumnAccess.Writers;

    using Documents.DocumentModel.Scope;

    public sealed class NVBytePostingFileConfig : IPostingFileConfig
    {
        public string Name
        {
            get { return "NVB"; }
        }

        public ScopeDirectory ScopeDirectory { get; set; }

        public AbstractDocumentIdColumnWriter DocumentIdWriter
        {
            get { return new PrefixVByteDocumentIdColumnWriter(); }
        }

        public AbstractFrequencyColumnWriter FrequencyWriter
        {
            get { return new PrefixVByteFrequencyColumnWriter(); }
        }

        public AbstractPositionColumnWriter PositionWriter
        {
            get { return new PrefixVBytePositionColumnWriter(); }
        }

        public AbstractScopeColumnWriter ScopeWriter
        {
            get { return new PrefixVByteScopeColumnWriter(); }
        }

        public AbstractDocumentColumnReader DocumentReader
        {
            get { return new PrefixVByteDocumentColumnReader(); }
        }

        public AbstractPositionColumnReader PositionReader
        {
            get { return new PrefixVBytePositionColumnReader(); }
        }

        public AbstractScopeColumnReader ScopeReader
        {
            get { return new PrefixVByteScopeColumnReader(); }
        }
    }
}
