﻿namespace NETing.Index.Controller.Configurations.ConcreteConfigurations
{
    using ColumnAccess.Implementations.NPfor;
    using ColumnAccess.Implementations.NPfor.ColumnWise;
    using ColumnAccess.Readers;
    using ColumnAccess.Writers;

    using Documents.DocumentModel.Scope;

    public sealed class PfxCNPforPostingFileConfig : IPostingFileConfig
    {
        private readonly NPforEncodingWrapper encodingWrapper = new NPforEncodingWrapper();

        public string Name
        {
            get { return "PfxCNPFor"; }
        }

        public ScopeDirectory ScopeDirectory { get; set; }

        public AbstractDocumentIdColumnWriter DocumentIdWriter
        {
            get { return new NPforDocumentIdColumnWriter(encodingWrapper); }
        }

        public AbstractFrequencyColumnWriter FrequencyWriter
        {
            get { return new NPforFrequencyColumnWriter(encodingWrapper); }
        }

        public AbstractPositionColumnWriter PositionWriter
        {
            get { return new NPforPostionColumnWriter(encodingWrapper); }
        }

        public AbstractScopeColumnWriter ScopeWriter
        {
            get { return new PfxCNPforScopeColumnWriter(ScopeDirectory, encodingWrapper); }
        }

        public AbstractDocumentColumnReader DocumentReader
        {
            get { return new NPforDocumentColumnReader(); }
        }

        public AbstractPositionColumnReader PositionReader
        {
            get { return new NPforPositionColumnReader(); }
        }

        public AbstractScopeColumnReader ScopeReader
        {
            get { return new PfxCNPforScopeColumnReader(); }
        }
    }
}
