﻿namespace NETing.Index.Controller.Configurations.ConcreteConfigurations
{
    using ColumnAccess.Implementations.Raw;
    using ColumnAccess.Readers;
    using ColumnAccess.Writers;

    using Documents.DocumentModel.Scope;

    public sealed class RawPostingFileConfig : IPostingFileConfig
    {
        public string Name
        {
            get { return "Raw"; }
        }

        public ScopeDirectory ScopeDirectory { get; set; }

        public AbstractDocumentIdColumnWriter DocumentIdWriter
        {
            get { return new RawDocumentIdColumnWriter(); }
        }

        public AbstractFrequencyColumnWriter FrequencyWriter
        {
            get { return new RawFrequencyColumnWriter(); }
        }

        public AbstractPositionColumnWriter PositionWriter
        {
            get { return new RawPositionColumnWriter();  }
        }

        public AbstractScopeColumnWriter ScopeWriter
        {
            get { return new RawScopeColumnWriter();  }
        }

        public AbstractDocumentColumnReader DocumentReader
        {
            get { return new RawDocumentColumnReader(); }
        }

        public AbstractPositionColumnReader PositionReader
        {
            get { return new RawPositionColumnReader(); }
        }

        public AbstractScopeColumnReader ScopeReader
        {
            get { return new RawScopeColumnReader(); }
        }
    }
}
