﻿namespace NETing.Index.Controller.Configurations.ConcreteConfigurations
{
    using ColumnAccess.Implementations.VByte;
    using ColumnAccess.Readers;
    using ColumnAccess.Writers;

    using Documents.DocumentModel.Scope;

    public sealed class VBytePostingFileConfig : IPostingFileConfig
    {
        public string Name
        {
            get { return "VB"; }
        }

        public ScopeDirectory ScopeDirectory { get; set; }

        public AbstractDocumentIdColumnWriter DocumentIdWriter
        {
            get { return new VByteDocumentIdColumnWriter(); }
        }

        public AbstractFrequencyColumnWriter FrequencyWriter
        {
            get { return new VByteFrequencyColumnWriter(); }
        }

        public AbstractPositionColumnWriter PositionWriter
        {
            get { return new VBytePositionColumnWriter(); }
        }

        public AbstractScopeColumnWriter ScopeWriter
        {
            get { return new VByteScopeColumnWriter(); }
        }

        public AbstractDocumentColumnReader DocumentReader
        {
            get { return new VByteDocumentColumnReader(); }
        }

        public AbstractPositionColumnReader PositionReader
        {
            get { return new VBytePositionColumnReader(); }
        }

        public AbstractScopeColumnReader ScopeReader
        {
            get { return new VByteScopeColumnReader(); }
        }
    }
}
