﻿namespace NETing.Index.Controller.Configurations
{
    using ColumnAccess.Readers;
    using ColumnAccess.Writers;
    using Documents.DocumentModel.Scope;

    public interface IPostingFileConfig
    {
        string Name { get; }

        ScopeDirectory ScopeDirectory { get; set; }
        
        AbstractDocumentIdColumnWriter DocumentIdWriter { get; }
        AbstractFrequencyColumnWriter FrequencyWriter { get; }
        AbstractPositionColumnWriter PositionWriter { get; }
        AbstractScopeColumnWriter ScopeWriter { get; }

        AbstractDocumentColumnReader DocumentReader { get; }
        AbstractPositionColumnReader PositionReader { get; }
        AbstractScopeColumnReader ScopeReader { get; }
    }
}


