﻿namespace NETing.Index.Controller.Services
{
    using System.IO;
    using System.Runtime.Serialization.Formatters.Binary;
    using Documents.DocumentModel.Scope;

    public sealed class ScopeDirectoryService
    {
        public ScopeDirectory ScopeDirectory { get; private set; }

        public StorageProfile StorageProfile { get; private set; }

        private bool read;

        public ScopeDirectoryService(
            ScopeDirectory scopeDirectory,
            StorageProfile storageProfile
            )
        {
            ScopeDirectory = scopeDirectory;
            StorageProfile = storageProfile;
        }

        public void Write()
        {
            using (Stream stream = StorageProfile.ScopeDirectoryFile.OpenWrite())
            {
                new BinaryFormatter().Serialize(stream, ScopeDirectory);
            }
        }

        public void Read()
        {
            if(read)
            {
                return;
            }

            using (Stream stream = StorageProfile.ScopeDirectoryFile.OpenRead())
            {
                ScopeDirectory = new BinaryFormatter().Deserialize(stream) as ScopeDirectory;
            }

            read = true;
        }
    }
}
