﻿namespace NETing.Index.Documents.DocumentModel
{
    using System;

    public sealed class Posting : IComparable<Posting>
    {
        public uint DocumentId;

        public uint Frequency;

        public ushort Position;

        public Scope.Scope Scope;

        public int CompareTo(Posting other)
        {
            int cmp = (int) (DocumentId - other.DocumentId);
            if (cmp != 0)
            {
                return cmp;
            }

            return (Position - other.Position);
        }

        public override string ToString()
        {
            return "<docId: " + DocumentId +
                   ", freq: " + Frequency +
                   ", pos: " + Position +
                   ", scope: " + Scope + ">";
        }

        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            if (obj.GetType() != typeof (Posting)) return false;
            return Equals((Posting) obj);
        }

        public bool Equals(Posting other)
        {
            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;
            return other.DocumentId == DocumentId 
                   && other.Frequency == Frequency 
                   && other.Position == Position 
                   && Equals(other.Scope, Scope);
        }

        public override int GetHashCode()
        {
            unchecked
            {
                int result = DocumentId.GetHashCode();
                result = (result * 397) ^ Frequency.GetHashCode();
                result = (result * 397) ^ Position.GetHashCode();
                result = (result * 397) ^ (Scope != null ? Scope.GetHashCode() : 0);
                return result;
            }
        }
    }
}


