﻿namespace NETing.Index.Documents.DocumentModel.Scope
{
    internal static class PathTypeLcp
    {
        public static PathType Lcp(PathType pathType1, PathType pathType2)
        {
            while (pathType1.PathId != pathType2.PathId)
            {
                if (pathType1.Depth > pathType2.Depth)
                {
                    pathType1 = pathType1.Parent;
                }
                else
                {
                    pathType2 = pathType2.Parent;
                }
            }

            return pathType1;
        }

        public static int[,] CalculateLcps(this ScopeDirectory scopeDirectory)
        {
            var table = new int[scopeDirectory.NumberOfPaths, scopeDirectory.NumberOfPaths];
            for (int i = 0; i < scopeDirectory.NumberOfPaths; i++)
            {
                for (int j = 0; j < scopeDirectory.NumberOfPaths; j++)
                {
                    table[i, j] = Lcp(scopeDirectory[i], scopeDirectory[j]).PathId;
                }
            }

            return table;
        }
    }
}
