﻿namespace NETing.Index.Documents.DocumentModel.Scope
{
    using System;

    [Serializable]
    public class Tag
    {
        public string Name;

        public int TagId;

        public bool IsAttribute;
        
        public override bool Equals(object obj)
        {
            return Equals(obj as Tag);
        }

        public bool Equals(Tag obj)
        {
            if (obj == null)
            {
                return false;
            }

            return obj.Name.Equals(Name) 
                && obj.IsAttribute == IsAttribute;
        }

        public override int GetHashCode()
        {
            return Name.GetHashCode() + 7 ^ IsAttribute.GetHashCode();
        }

        public override string ToString()
        {
            return (IsAttribute ? "@" : "") + Name;
        }
    }
}


