﻿namespace NETing.Index.FileProcessor
{
    using System.IO;
    using System.Threading.Tasks;
    
    using Documents.DocumentModel;

    public static class DocumentLoader
    {
        public static Task<Document> LoadDocument(Document doc)
        {
            return Task<Document>.Factory.StartNew(() => DoLoadDocument(doc));
        }

        private static Document DoLoadDocument(Document doc)
        {
            Stream memoryStream = new MemoryStream((int)doc.Content.Length);
            doc.Content.CopyTo(memoryStream);
            doc.Content.Dispose();
            doc.Content = memoryStream;
            memoryStream.Seek(0, SeekOrigin.Begin);
            return doc;
        }
    }
}
