﻿namespace NETing.Index.Inversion
{
    internal class InversionStore
    {
        public int StoreIndex { get; private set; }

        public byte[] Buffer { get; private set; }

        public int HighWaterMark { get; private set; }

        public int Remaining
        {
            get { return Buffer.Length - HighWaterMark; }
        }

        public InversionStore(int storeSize, int index)
        {
            Buffer = new byte[storeSize];
            StoreIndex = index;
        }

        public int AllocateSegment(int size)
        {
            if (HighWaterMark + size <= Buffer.Length)
            {
                int start = HighWaterMark;
                HighWaterMark += size;
                return start;
            }

            return -1;
        }
    }
}
