﻿namespace NETing.Index.PathMatching.Syntax
{
    using System.Collections.Generic;

    internal class Parser
    {
        public static IEnumerable<ExpressionToken> ParseExpression(string expression)
        {
            char[] chars = expression.ToCharArray();
            int position = 0;
            while (position < chars.Length)
            {
                if (chars[position] == '/')
                {
                    if (position < (chars.Length - 1) 
                        && chars[position + 1] == '/')
                    {
                        yield return new ExpressionToken
                                         {
                                             Type = TokenType.Descendant,
                                             Position = position
                                         };
                        position++;
                    }
                    else
                    {
                        yield return new ExpressionToken
                                         {
                                             Type = TokenType.Child,
                                             Position = position
                                         };
                    }
                }
                else
                {
                    var token = new ExpressionToken
                                    {
                                        Type = TokenType.ElementTag,
                                        Position = position
                                    };

                    while (position < (chars.Length - 1) && chars[position + 1] != '/')
                    {
                        position++;                    
                    }

                    token.Value = new string(chars, token.Position, position - token.Position + 1);
                    yield return token;
                }

                position++;
            }
        }
    }
}


