﻿namespace NETing.Index.QueryLanguage
{
    using System;
    using System.Collections.Generic;
    using Documents.DocumentModel.Scope;
    using Documents.Parser;

    [Serializable]
    internal class Query
    {
        public int Id { get; set; }

        public bool Dense { get; set; }

        public Term[] Terms { get; private set; }

        public IEnumerable<PathType> PathTypes { get; private set; }

        internal Query(Term[] terms)
        {
            Terms = terms;
        }

        internal Query(Term[] terms, IEnumerable<PathType> pathTypes, bool dense = false)
        {
            Terms = terms;
            PathTypes = pathTypes;
        }
    }
}


