﻿namespace NETing.Index.Search.ScopeIntersection
{
    using System.Collections.Generic;
    using Documents.DocumentModel.Scope;
    using PostingFile;

    public sealed class DenseScopeIntersectionQueryItem : AbstractScopeIntersectionQueryItem
    {
        internal DenseScopeIntersectionQueryItem(
            ScopeDirectory scopeDirectory,
            PostingFileEnumerator[] lists, 
            IEnumerable<PathType> queryPathTypes) 
            : base(scopeDirectory, lists, queryPathTypes)
        {
        }

        public override bool MoveNext()
        {
            while (!exhausted)
            {
                uint docId = heap.Array[0].Enumerator.Current.DocumentId;
                int position;
                for (position = 1; position < listHolders.Length; position++)
                {
                    var enumerator = heap.Array[position].Enumerator;
                    if (enumerator.Current.DocumentId < docId)
                    {
                        if (!enumerator.SkipToPathIdAndDocumentId(candidatePathTypes, docId))
                        {
                            exhausted = true;
                            return false;
                        }

                        if (enumerator.Current.DocumentId > docId)
                        {
                            heap.Heapify();
                            break;
                        }
                    }
                    else if (!candidatePathTypes[enumerator.Current.Scope.PathType.PathId])
                    {
                        if (!enumerator.SkipToPathTypes(candidatePathTypes))
                        {
                            exhausted = true;
                            return false;
                        }

                        if (enumerator.Current.DocumentId > docId)
                        {
                            heap.Heapify();
                            break;
                        }
                    }
                }

                if (position == listHolders.Length && FindTrueMatch())
                {
                    heap.Heapify();
                    return true;
                }

                heap.Heapify();
            }

            return false;
        }
    }
}
