﻿namespace NETing.Index.Storage.Buffer
{
    internal struct BufferKey
    {
        public long BlockNumber { get; private set; }

        public BufferKey(long blockNumber) : this()
        {
            BlockNumber = blockNumber;
        }

        public override string ToString()
        {
            return "<" + BlockNumber + ">";
        }

        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (obj.GetType() != typeof (BufferKey)) return false;
            return Equals((BufferKey) obj);
        }

        public bool Equals(BufferKey other)
        {
            return other.BlockNumber == BlockNumber;
        }

        public override int GetHashCode()
        {
            unchecked
            {
                return BlockNumber.GetHashCode();
            }
        }
    }
}


