﻿namespace NETing.Index.Storage
{
    public interface IBlockReader : IBlockAccess
    {
        /// <summary>
        /// Read one block into the supplied buffer. 
        /// </summary>
        /// <param name="blockPosition">The block to be read.</param>
        /// <param name="buffer">The buffer to read the data into.</param>
        /// <param name="bufferOffset">The offset in the buffer to insert the data into.</param>
        void ReadBlock(long blockPosition, byte[] buffer, int bufferOffset);

        /// <summary>
        /// Read one block into the supplied buffer. 
        /// </summary>
        /// <param name="blockPosition">The block to be read.</param>
        /// <param name="blocks">The number of blocks to read.</param>
        /// <param name="buffer">The buffer to read the data into.</param>
        /// <param name="bufferOffset">The offset in the buffer to insert the data into.</param>
        void ReadBlocks(long blockPosition, int blocks, byte[] buffer, int bufferOffset);
    }
}


