﻿namespace NETing.Index.Storage
{
    public interface IBlockWriter : IBlockAccess
    {
        /// <summary>
        /// Write one block from the buffer at <paramref name="blockPosition"/>
        /// in the file. The data is fetched from <paramref name="buffer"/> 
        /// and the data written are 
        /// <c>buffer[bufferOffset ... bufferOffset + BlockSize]</c>
        /// </summary>
        /// <param name="blockPosition">The block position to write at.</param>
        /// <param name="buffer">The buffer to fetch data from.</param>
        /// <param name="bufferOffset">The starting position in the buffer.</param>
        void WriteBlock(long blockPosition, byte[] buffer, int bufferOffset);
    }
}


