﻿namespace NETing.Index.Utils.Benchmark
{
    using System.Runtime.InteropServices;

    public static class Timing
    {
        private static class NativeCalls
        {
            [DllImport("KERNEL32")]
            public static extern bool QueryPerformanceCounter(ref long performanceCount);

            [DllImport("KERNEL32")]
            public static extern bool QueryPerformanceFrequency(ref long frequency);
        }

        public static double PerformanceCountToNanoSeconds(long count)
        {
            return count * 1.0e9 / PerformanceCounterFrequency;
        }

        public static long PerformanceCounter
        {
            get
            {
                long count = 0;
                NativeCalls.QueryPerformanceCounter(ref count);
                return count;
            }
        }

        public static long PerformanceCounterFrequency
        {
            get
            {
                long freq = 0;
                NativeCalls.QueryPerformanceFrequency(ref freq);
                return freq;
            }
        }
    }
}


