﻿namespace NETing.Index.Utils.Collections
{
    using System;

    [Serializable]
    internal sealed class Pair<T1, T2> : IEquatable<Pair<T1, T2>>
    {
        private T1 first;
        private T2 second;

        public T1 First
        {
            get { return first; }
            set { first = value; }
        }

        public T2 Second
        {
            get { return second; }
            set { second = value; }
        }

        public Pair(T1 first, T2 second)
        {
            this.first = first;
            this.second = second;
        }

        public bool Equals(Pair<T1, T2> other)
        {
            return first.Equals(other.first) && second.Equals(other.second);
        }

        public override int GetHashCode()
        {
            return first.GetHashCode() ^ 7 * second.GetHashCode();
        }
    }
}


