#include "StdAfx.h"
#include "FastPack.h"
#include "Packers.h"
#include "UnPackers.h"

#pragma unmanaged
void unmanagedFastPack(int width, const unsigned int* input, unsigned int* output)
{
	packers.pack[width](input, output);
	packers.pack[width](input + 32, output + width);
	packers.pack[width](input + 64, output + width + width);
	packers.pack[width](input + 96, output + width + width + width);
}

#pragma unmanaged
void unmanagedFastUnPack(int width, const unsigned int* input, unsigned int* output)
{
	unPackers.unpack[width](input, output);
	unPackers.unpack[width](input + width, output + 32);
	unPackers.unpack[width](input + width + width, output + 64);
	unPackers.unpack[width](input + width + width + width, output + 96);
}

#pragma managed
namespace NETing { namespace Index { namespace NativeCode {

	void FastPack::FastPack128(int width, const unsigned int* input, unsigned int* output)
	{
		unmanagedFastPack(width, input, output);
	}

	void FastPack::FastUnPack128(int width, const unsigned int* input, unsigned int* output)
	{
		unmanagedFastUnPack(width, input, output);
	}
}}}