#include "StdAfx.h"
#include "Simple9.h"

#pragma unmanaged
int decodeA(unsigned int encoded, unsigned int* output)
{
    output[0] = (encoded >> 27) & 1;
    output[1] = (encoded >> 26) & 1;
    output[2] = (encoded >> 25) & 1;
    output[3] = (encoded >> 24) & 1;
    output[4] = (encoded >> 23) & 1;
    output[5] = (encoded >> 22) & 1;
    output[6] = (encoded >> 21) & 1;
    output[7] = (encoded >> 20) & 1;
    output[8] = (encoded >> 19) & 1;
    output[9] = (encoded >> 18) & 1;
    output[10] = (encoded >> 17) & 1;
    output[11] = (encoded >> 16) & 1;
    output[12] = (encoded >> 15) & 1;
    output[13] = (encoded >> 14) & 1;
    output[14] = (encoded >> 13) & 1;
    output[15] = (encoded >> 12) & 1;
    output[16] = (encoded >> 11) & 1;
    output[17] = (encoded >> 10) & 1;
    output[18] = (encoded >> 9) & 1;
    output[19] = (encoded >> 8) & 1;
    output[20] = (encoded >> 7) & 1;
    output[21] = (encoded >> 6) & 1;
    output[22] = (encoded >> 5) & 1;
    output[23] = (encoded >> 4) & 1;
    output[24] = (encoded >> 3) & 1;
    output[25] = (encoded >> 2) & 1;
    output[26] = (encoded >> 1) & 1;
    output[27] = encoded & 1;

    return 28;
}

#pragma unmanaged
int decodeB(unsigned int encoded, unsigned int* output)
{
    output[0] = (encoded >> 26) & 3;
    output[1] = (encoded >> 24) & 3;
    output[2] = (encoded >> 22) & 3;
    output[3] = (encoded >> 20) & 3;
    output[4] = (encoded >> 18) & 3;
    output[5] = (encoded >> 16) & 3;
    output[6] = (encoded >> 14) & 3;
    output[7] = (encoded >> 12) & 3;
    output[8] = (encoded >> 10) & 3;
    output[9] = (encoded >> 8) & 3;
    output[10] = (encoded >> 6) & 3;
    output[11] = (encoded >> 4) & 3;
    output[12] = (encoded >> 2) & 3;
    output[13] = encoded & 3;

    return 14;
}

#pragma unmanaged
int decodeC(unsigned int encoded, unsigned int* output)
{
    output[0] = (encoded >> 25) & 7;
    output[1] = (encoded >> 22) & 7;
    output[2] = (encoded >> 19) & 7;
    output[3] = (encoded >> 16) & 7;
    output[4] = (encoded >> 13) & 7;
    output[5] = (encoded >> 10) & 7;
    output[6] = (encoded >> 7) & 7;
    output[7] = (encoded >> 4) & 7;
    output[8] = (encoded >> 1) & 7;

    return 9;
}

#pragma unmanaged
int decodeD(unsigned int encoded, unsigned int* output)
{
    output[0] = (encoded >> 24) & 15;
    output[1] = (encoded >> 20) & 15;
    output[2] = (encoded >> 16) & 15;
    output[3] = (encoded >> 12) & 15;
    output[4] = (encoded >> 8) & 15;
    output[5] = (encoded >> 4) & 15;
    output[6] = encoded & 15;

    return 7;
}

#pragma unmanaged
int decodeE(unsigned int encoded, unsigned int* output)
{
    output[0] = (encoded >> 23) & 31;
    output[1] = (encoded >> 18) & 31;
    output[2] = (encoded >> 13) & 31;
    output[3] = (encoded >> 8) & 31;
    output[4] = (encoded >> 3) & 31;

    return 5;
}

#pragma unmanaged
int decodeF(unsigned int encoded, unsigned int* output)
{
    output[0] = (encoded >> 21) & 127;
    output[1] = (encoded >> 14) & 127;
    output[2] = (encoded >> 7) & 127;
    output[3] = encoded & 127;

    return 4;
}

#pragma unmanaged
int decodeG(unsigned int encoded, unsigned int* output)
{
    output[0] = (encoded >> 19) & 511;
    output[1] = (encoded >> 10) & 511;
    output[2] = (encoded >> 1) & 511;

    return 3;
}

#pragma unmanaged
int decodeH(unsigned int encoded, unsigned int* output)
{
    for (int i = 0, pos = 14; i < 2; i++, pos -= 14)
    {
        output[i] = (encoded >> pos) & 16383;
    }

    return 2;
}

#pragma unmanaged
int decodeI(unsigned int encoded, unsigned int* output)
{
    output[0] = encoded & 268435455;
    return 1;
}

#pragma unmanaged
int Simple9::Decode(unsigned int encoded, unsigned int* output, int outputOffset)
{
	unsigned int* out = &output[outputOffset];
	switch (encoded >> 28)
	{
		case 0: return decodeA(encoded, out);
        case 1: return decodeB(encoded, out);
        case 2: return decodeC(encoded, out);
        case 3: return decodeD(encoded, out);
        case 4: return decodeE(encoded, out);
        case 5: return decodeF(encoded, out);
        case 6: return decodeG(encoded, out);
        case 7: return decodeH(encoded, out);
        default:return decodeI(encoded, out);
	}

	return 0;
}