set terminal postscript enhanced landscape color lw 1 "Helvetica" 14 
set output "intersecton.histogram.throughput.eps"

set style histogram clustered gap 3
set style data histograms
set style fill solid 1 border -1

set key right
set key spacing 0.8
set key samplen 0.7

set xlabel "Resultset size"
set ylabel "QPS"

set yrange [0:*]

plot "intersection.histogram.throughput.dat" u 13:xtic(1) t '{/Helvetica=10 Raw}',\
     "intersection.histogram.throughput.dat" u 14 t '{/Helvetica=10 VB}',\
     "intersection.histogram.throughput.dat" u 9 t '{/Helvetica=10 NVB}',\
	 "intersection.histogram.throughput.dat" u 8 t '{/Helvetica=10 PFor}',\
	 "intersection.histogram.throughput.dat" u 12 t '{/Helvetica=10 PTS.PFor}',\
	 "intersection.histogram.throughput.dat" u 2 t '{/Helvetica=10 CPFor}',\
	 "intersection.histogram.throughput.dat" u 10 t '{/Helvetica=10 Pf.CPFor}',\
	 "intersection.histogram.throughput.dat" u 11 t '{/Helvetica=10 PTS.CPFor}',\
	 "intersection.histogram.throughput.dat" u 3 t '{/Helvetica=10 D.CPFor.100}',\
	 "intersection.histogram.throughput.dat" u 4 t '{/Helvetica=10 D.CPFor.16}' fs solid 0.2,\
	 "intersection.histogram.throughput.dat" u 5 t '{/Helvetica=10 D.CPFor.32}' fs solid 0.2,\
	 "intersection.histogram.throughput.dat" u 6 t '{/Helvetica=10 D.CPFor.64}' fs solid 0.2,\
	 "intersection.histogram.throughput.dat" u 7 t '{/Helvetica=10 D.CPFor.8}' fs solid 0.2