set terminal postscript enhanced landscape color lw 1 "Helvetica" 14 
set output "intersecton.threads.throughput.eps"

# set style histogram clustered gap 3
# set style data histograms
# set style fill solid 1 border -1

set key left
set key spacing 0.8
set key samplen 0.7

set xlabel "Threads"
set ylabel "QPS"

set xrange [-0.1:3.1]
set yrange [0:*]

plot "intersection.threads.throughput.dat" u 13:xtic(1) t '{/Helvetica=10 Raw}' w lp, \
     "intersection.threads.throughput.dat" u 14 t '{/Helvetica=10 VB}' w lp,\
     "intersection.threads.throughput.dat" u 9 t '{/Helvetica=10 NVB}' w lp,\
	 "intersection.threads.throughput.dat" u 8 t '{/Helvetica=10 PFor}' w lp,\
	 "intersection.threads.throughput.dat" u 12 t '{/Helvetica=10 PTS.PFor}' w lp,\
	 "intersection.threads.throughput.dat" u 2 t '{/Helvetica=10 CPFor}' w lp,\
	 "intersection.threads.throughput.dat" u 10 t '{/Helvetica=10 Pf.CPFor}' w lp,\
	 "intersection.threads.throughput.dat" u 11 t '{/Helvetica=10 PTS.CPFor}' w lp,\
	 "intersection.threads.throughput.dat" u 3 t '{/Helvetica=10 D.CPFor.100}' w lp,\
	 "intersection.threads.throughput.dat" u 4 t '{/Helvetica=10 D.CPFor.16}' w lp,\
	 "intersection.threads.throughput.dat" u 5 t '{/Helvetica=10 D.CPFor.32}' w lp,\
	 "intersection.threads.throughput.dat" u 6 t '{/Helvetica=10 D.CPFor.64}' w lp,\
	 "intersection.threads.throughput.dat" u 7 t '{/Helvetica=10 D.CPFor.8}' w lp