set terminal postscript enhanced landscape color lw 1 "Helvetica" 14 
set output "managed.path.sentence.histogram.throughput.eps"

set style histogram clustered gap 3
set style data histograms
set style fill solid border 31

set key left
set key horiz


set key spacing 0.8
set key samplen 0.7

set ylabel "QPS"

set yrange [0:*]
set xtics nomirror rotate by -45 scale 0

plot newhistogram "", "managed.path.sentence.histogram.throughput.dat" u 8:xtic(1) t '{/Helvetica=10 PFor}' fs border lt -1,\
				  "managed.path.sentence.histogram.throughput.dat" u 18 t '{/Helvetica=10 M.PFor}' fs border rgb "black",\
	 newhistogram "", "managed.path.sentence.histogram.throughput.dat" u 11:xtic(1) t '{/Helvetica=10 PTS.PFor}' fs border lt -1,\
	              "managed.path.sentence.histogram.throughput.dat" u 21 t '{/Helvetica=10 M.PTS.PFor}' fs border -1,\
	 newhistogram "", "managed.path.sentence.histogram.throughput.dat" u 2:xtic(1) t '{/Helvetica=10 CPFor}',\
	              "managed.path.sentence.histogram.throughput.dat" u 12 t '{/Helvetica=10 M.CPFor}',\
	 newhistogram "", "managed.path.sentence.histogram.throughput.dat" u 9:xtic(1) t '{/Helvetica=10 Pf.CPFor}',\
				  "managed.path.sentence.histogram.throughput.dat" u 19 t '{/Helvetica=10 M.Pf.CPFor}',\
	 newhistogram ", "managed.path.sentence.histogram.throughput.dat" u 10:xtic(1) t '{/Helvetica=10 PTS.CPFor}',\
				  "managed.path.sentence.histogram.throughput.dat" u 20 t '{/Helvetica=10 M.PTS.CPFor}',\
	 newhistogram "", "managed.path.sentence.histogram.throughput.dat" u 5:xtic(1) t '{/Helvetica=10 D.CPFor.32}',\
	              "managed.path.sentence.histogram.throughput.dat" u 15 t '{/Helvetica=10 M.D.CPFor.32}'
				  
				  
				  
				  
			