from lib import *
PREFIX = "../"


def intersectionHistogram():
    res = []
    path = PREFIX + "ThesisExperiments\intersection.histogram."
    for last in ["max11res", "max21res", "max31res", "max41res", "max51res"]:
        res.append(results(path + last))

    print(buildPlotHeader("size", res[0]))
    i = 0
    for limits in ["1-10","11-20","21-30","31-40","41-50"]:
        print(buildPlotLine(limits, 0, 3, res[i]))
        i = i + 1

def sentenceHistogram():
    res = []
    path = PREFIX + "ThesisExperiments\path.sentence.histogram."
    for last in ["max11res", "max21res", "max31res", "max41res", "max51res"]:
        res.append(results(path + last))

    print(buildPlotHeader("size", res[0]))
    i = 0
    for limits in ["1-10","11-20","21-30","31-40","41-50"]:
        print(buildPlotLine(limits, 0, 3, res[i]))
        i = i + 1

def threadsPlot():
    res = []
    path = PREFIX + "ThesisExperiments\intersection.threads."
    for nt in map(str, [1, 2, 4, 8]):
        res.append(results(path + nt + ".threads"))

    i = 0
    print(buildPlotHeader("threads", res[0]))
    for threads in ["1","2","4","8"]:
        print(buildPlotLine(threads, 0, 3, res[i]))
        i = i + 1

    i = 0
    print(buildPlotHeader("threads", res[0]))
    for threads in (1,2,4,8):
        for r in res[i].values():
            r[0][3] = r[0][3] / threads

        print(buildPlotLine(str(threads), 0, 3, res[i]))
        i = i + 1

    i = 0
    print(buildPlotHeader("threads", res[0]))
    for threads in ["1","2","4","8"]:
        print(buildPlotLine(threads, 1, 2, res[i]))
        i = i + 1

def skipMethods():
    res = []
    path = PREFIX + "ThesisExperiments\path."
    for experiments in ["sentence.regular", "sentence.dense",
                        "person.regular", "person.dense",
                        "title.regular", "title.dense",
                        "company.regular", "company.dense"]:
        res.append(results(path + experiments))

    i = 0
    print(buildPlotHeader("method", res[0]))
    for experiments in ["sentence.docid", "sentence.pathtype",
                        "person.docid", "person.pathtype",
                        "title.docid", "title.pathtype",
                        "company.docid", "company.pathtype"]:
        print(buildPlotLine(experiments, 0, 3, res[i]))
        i = i + 1

def combineResults(results1, results2, sencondPrefix):
    result = dict(results1)
    for (k, v) in results2.items():
        result[sencondPrefix + k] = v
    return result

def managedSentence():
    res = []
    path1 = PREFIX + "ThesisExperiments\path.sentence.histogram."
    path2 = PREFIX + "ThesisExperiments\managed.path.sentence.histogram."
    for last in ["max11res", "max21res", "max31res", "max41res", "max51res"]:
        res.append(combineResults(results(path1 + last), results(path2 + last), "U."))

    print(buildPlotHeader("size", res[0]))
    i = 0
    for limits in ["1-10","11-20","21-30","31-40","41-50"]:
        print(buildPlotLine(limits, 0, 3, res[i]))
        i = i + 1

def managedIntersection():
    res = []
    path1 = PREFIX + "ThesisExperiments\intersection.histogram."
    path2 = PREFIX + "ThesisExperiments\managed.intersection.histogram."
    for last in ["max11res", "max21res", "max31res", "max41res", "max51res"]:
        res.append(combineResults(results(path1 + last), results(path2 + last), "U."))

    print(buildPlotHeader("size", res[0]))
    i = 0
    for limits in ["1-10","11-20","21-30","31-40","41-50"]:
        print(buildPlotLine(limits, 0, 3, res[i]))
        i = i + 1

intersectionHistogram()
sentenceHistogram()
threadsPlot()
skipMethods()
managedIntersection()
managedSentence()
