import math
import os

def maxThroughput(lines):
    bestLine = None
    best = -10000
    for l in lines:
        elements = list(map(lambda x: float(x.replace(",",".")), l.split()))
        if elements[3] > best:
            best = elements[3]
            bestLine = elements
    bestLine[0] = int(bestLine[0])            
    bestLine[2] = bestLine[2] / int(bestLine[0])
    return bestLine

def minLatency(lines):
    bestLine = None
    best = 1000000000000
    for l in lines:
        elements = list(map(lambda x: float(x.replace(",",".")), l.split()))
        if elements[2] < best:
            best = elements[2]
            bestLine = elements
    bestLine[0] = int(bestLine[0])
    bestLine[2] = bestLine[2] / int(bestLine[0])
    return bestLine

def getData(fileName):
    f = open(fileName)
    lines = list(f.readlines())
    return maxThroughput(lines), minLatency(lines)

def getExperimentResults(directory):
    files = os.listdir(directory)
    for f in files:
        if f.split(".")[-1] != "timing": continue
        name = f.split(".")[-2]
        yield (name, getData(directory + "\\" + f))

def results(directory): return dict(getExperimentResults(directory))

def buildPlotHeader(header, results):
    res = ["#" + header]
    for expr in sorted(results.keys()):
        res.append(expr)
    return "\t".join(res)

def buildPlotLine(header, metric, column, results):
    res = [header]
    for expr in sorted(results.keys()):
        res.append(str(results[expr][metric][column]))
    return "\t".join(res)
