from lib import *
PREFIX = "../"


def intersectionHistogram():
    res = []
    path = PREFIX + "ThesisExperiments\intersection.histogram."
    for last in ["max11res", "max21res", "max31res", "max41res", "max51res"]:
        res.append(results(path + last))

    print(buildPlotHeader("size", res[0]))
    i = 0
    for limits in ["1-10","11-20","21-30","31-40","41-50"]:
        print(buildPlotLine(limits, 0, 3, res[i]))
        i = i + 1

def sentenceHistogram():
    res = []
    path = PREFIX + "ThesisExperiments\path.sentence.histogram."
    for last in ["max11res", "max21res", "max31res", "max41res", "max51res"]:
        res.append(results(path + last))

    print(buildPlotHeader("size", res[0]))
    i = 0
    for limits in ["1-10","11-20","21-30","31-40","41-50"]:
        print(buildPlotLine(limits, 0, 3, res[i]))
        i = i + 1

def threadsPlot():
    res = []
    path = PREFIX + "ThesisExperiments\intersection.threads."
    for nt in map(str, [1, 2, 4, 8]):
        res.append(results(path + nt + ".threads"))

    i = 0
    print(buildPlotHeader("threads", res[0]))
    for threads in ["1","2","4","8"]:
        print(buildPlotLine(threads, 0, 3, res[i]))
        i = i + 1

    i = 0
    print(buildPlotHeader("threads", res[0]))
    for threads in (1,2,4,8):
        for r in res[i].values():
            r[0][3] = r[0][3] / threads

        print(buildPlotLine(str(threads), 0, 3, res[i]))
        i = i + 1

    i = 0
    print(buildPlotHeader("threads", res[0]))
    for threads in ["1","2","4","8"]:
        print(buildPlotLine(threads, 1, 2, res[i]))
        i = i + 1

def skipMethods():
    res = []
    path = PREFIX + "ThesisExperiments\path."
    for experiments in ["sentence.regular", "sentence.dense",
                        "person.regular", "person.dense",
                        "title.regular", "title.dense",
                        "company.regular", "company.dense"]:
        res.append(results(path + experiments))

    i = 0
    print(buildPlotHeader("method", res[0]))
    for experiments in ["sentence.docid", "sentence.pathtype",
                        "person.docid", "person.pathtype",
                        "title.docid", "title.pathtype",
                        "company.docid", "company.pathtype"]:
        print(buildPlotLine(experiments, 0, 3, res[i]))
        i = i + 1

def combineResults(results1, results2, sencondPrefix):
    result = dict(results1)
    for (k, v) in results2.items():
        result[sencondPrefix + k] = v
    return result

def managedSentence():
    res = []
    path1 = PREFIX + "ThesisExperiments\path.sentence.histogram."
    path2 = PREFIX + "ThesisExperiments\managed.path.sentence.histogram."
    for last in ["max11res", "max21res", "max31res", "max41res", "max51res"]:
        res.append(combineResults(results(path1 + last), results(path2 + last), "U."))

    print(buildPlotHeader("size", res[0]))
    i = 0
    for limits in ["1-10","11-20","21-30","31-40","41-50"]:
        print(buildPlotLine(limits, 0, 3, res[i]))
        i = i + 1

def buildTableHeader(experiments):
    lines = []
    line = [""]
    for exp in experiments:
        line.append("\\multicolumn{2}{c|}{\\textbf{" + exp + "}}")
    lines.append("\t&\t".join(line))
    line = [""]
    for i in range(len(experiments)):
        line.append("\\textbf{T}")
        line.append("\\textbf{L}")
    lines.append("\t&\t".join(line))

    return "\\hline" + "\\\\\\hline \r\n".join(lines) + "\r\n\\\\\\hline\\hline"
        
def buildTableLine(results, key):
    line = ["\\textbf{" + key[1] + "}"] 
    for res in results:
        if key[0] in res:
            res = res[key[0]][0]
            line.extend(reversed(res[2:4]))

    for i in range(1, len(line)):
        line[i] = "$%.3f$" % line[i]
    return "\t&\t".join(line) + "\\\\"


keys = [
        ("Raw", "Raw"),
        ("VB", "VB"),
        ("NVB", "NVB"),
        ("NPFor", "PFor"),
        ("M.NPFor", "M.PFor"),
        ("PtsNPFor", "Pts.PFor"),
        ("M.PtsNPFor", "M.Pts.PFor"),
        ("CNPFor", "CPFor"),
        ("M.CNPFor", "M.CPFor"),
        ("PfxCNPFor", "Pf.CPFor"),
        ("M.PfxCNPFor", "M.Pf.CPFor"),
        ("PtsCNPFor", "Pts.CPFor"),
        ("M.PtsCNPFor", "M.Pts.CPFor"),
        ("DCNPFor100", "D.PFor.100"),
        ("M.DCNPFor100", "M.D.PFor.100"),
        ("DCNPFor64", "D.PFor.64"),
        ("M.DCNPFor64", "M.D.PFor.64"),
        ("DCNPFor32", "D.PFor.32"),
        ("M.DCNPFor32", "M.D.PFor.32"),
        ("DCNPFor16", "D.PFor.16"),
        ("M.DCNPFor16", "M.D.PFor.16"),
        ("DCNPFor8", "D.PFor.8"),
        ("M.DCNPFor8", "M.D.PFor.8"),
         ]

def threads():
    res = []
    path = PREFIX + "ThesisExperiments\intersection.threads."
    for nt in map(str, [1, 2, 4, 8]):
        res.append(results(path + nt + ".threads"))

    print(buildTableHeader(["1", "2", "4", "8"]))
    for key in keys:
        print(buildTableLine(res, key))

def skipMethods():
    res = []
    path = PREFIX + "ThesisExperiments\path."
    for experiments in ["sentence.regular", "sentence.dense",
                        "person.regular", "person.dense"]:
        res.append(results(path + experiments))

    print(buildTableHeader(["sentence.regular", "sentence.dense",
                        "person.regular", "person.dense"]))
    for key in keys:
        print(buildTableLine(res, key))

    res = []
    for experiments in ["title.regular", "title.dense",
                        "company.regular", "company.dense"]:
        res.append(results(path + experiments))

    print(buildTableHeader(["title.regular", "title.dense",
                        "company.regular", "company.dense"]))
    for key in keys:
        print(buildTableLine(res, key))

def managedIntersection():
    res = []
    path1 = PREFIX + "ThesisExperiments\intersection.histogram."
    path2 = PREFIX + "ThesisExperiments\managed.intersection.histogram."
    for last in ["max11res", "max21res", "max31res", "max41res", "max51res"]:
        res.append(combineResults(results(path1 + last), results(path2 + last), "M."))

    print(buildTableHeader(["1-10", "11-20", "21-30", "31-40", "41-50"]))
    for key in keys:
        print(buildTableLine(res, key))

def managedSentence():
    res = []
    path1 = PREFIX + "ThesisExperiments\path.sentence.histogram."
    path2 = PREFIX + "ThesisExperiments\managed.path.sentence.histogram."
    for last in ["max11res", "max21res", "max31res", "max41res", "max51res"]:
        res.append(combineResults(results(path1 + last), results(path2 + last), "M."))

    print(buildTableHeader(["1-10", "11-20", "21-30", "31-40", "41-50"]))
    for key in keys:
        print(buildTableLine(res, key))

skipMethods()
